from Products.ZPatterns.Rack import Rack
from Products.PlugIns import MakePICBase
from Globals import DTMLFile, default__class_init__, PersistentMapping
from Products.CMFCore.Skinnable import SkinnableObjectManager
from Products.CMFCore.utils import getToolByName

class SkinnableRack(Rack, SkinnableObjectManager):

    meta_type = "SkinnableRack"

    __getattr__ = SkinnableObjectManager.__getattr__
    __of__ = SkinnableObjectManager.__of__
    _checkId = SkinnableObjectManager._checkId

    def getSkinsFolderName(self):
        # Not implemented.
        return 'portal_skins'

    def setup(self, globals_dict):
        """ Add skins to specialist """
        addCMFCoreTool = self.manage_addProduct['CMFCore'].manage_addTool
        addCMFCoreTool('CMF Skins Tool', None)

        from Products.CMFCore.DirectoryView import addDirectoryViews
        ps = getToolByName(self, 'portal_skins')
        addDirectoryViews(ps, 'rackskins', globals_dict)
        ps.manage_addProduct['OFSP'].manage_addFolder(id='custom')
        ps.addSkinSelection('Basic', 'custom, default', make_default=1)
        self.setupCurrentSkin()

default__class_init__(SkinnableRack); MakePICBase(SkinnableRack)

manage_addSkinnableRackForm = DTMLFile('dtml/addSkinnableRack', globals())

def manage_addSkinnableRack(self, id, title='', REQUEST=None):
    """Add a Skinnable Rack"""
    ob = SkinnableRack(id, title)
    ob = ob.__of__(self)
    ob.setup(globals())
    return self.Destination()._installPlugIn(ob, 'Added Rack.',REQUEST)


def initialize(context):

    context.registerPlugInClass(
        SkinnableRack,
        permission = 'Add SkinnableRacks',
        constructors = (manage_addSkinnableRackForm,
                        manage_addSkinnableRack),
        icon = 'www/rack.gif',
    )

    context.registerPIContainerBase(SkinnableRack)
